diff --git a/src/main/java/net/minecraft/client/render/entity/ScorpionRenderer.java b/src/main/java/net/minecraft/client/render/entity/ScorpionRenderer.java
index 84d4df4cc..50b5de73b 100644
--- a/src/main/java/net/minecraft/client/render/entity/ScorpionRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ScorpionRenderer.java
@@ -1,35 +1,29 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelScorpion;
-import net.minecraft.core.entity.monster.EntityScorpion;
+import net.minecraft.client.render.model.ScorpionModel;
+import net.minecraft.core.entity.monster.ScorpionMob;
 
-public class ScorpionRenderer extends LivingRenderer<EntityScorpion>
+public class ScorpionRenderer extends MobRenderer<ScorpionMob>
 {
 
     public ScorpionRenderer()
     {
-        super(new ModelScorpion(), 0.5F);
-        setRenderPassModel(new ModelScorpion());
+        super(new ScorpionModel(), 0.5F);
+        setArmorModel(new ScorpionModel());
     }
-
-    protected float setMaxDeathRotation(EntityScorpion scorpion)
-    {
-        return 180F;
-    }
-
-    protected boolean doRenderPass(EntityScorpion scorpion, int i, float f)
+    protected boolean doRenderPass(ScorpionMob scorpion, int i, float f)
     {
         return i == 0;
     }
 
     @Override
-    protected float getDeathMaxRotation(EntityScorpion entity)
+    protected float getMaxDeathRotation(ScorpionMob entity)
     {
-        return setMaxDeathRotation(entity);
+        return 180F;
     }
 
     @Override
-    protected boolean shouldRenderPass(EntityScorpion entity, int renderPass, float partialTick)
+    protected boolean prepareArmor(ScorpionMob entity, int renderPass, float partialTick)
     {
         return doRenderPass(entity, renderPass, partialTick);
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java b/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
index 495bcad9f..bbb21fe02 100644
--- a/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
@@ -1,37 +1,37 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.model.BaseModel;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.core.Global;
-import net.minecraft.core.entity.animal.EntitySheep;
+import net.minecraft.core.entity.animal.SheepMob;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntitySheep, ModelBase, EntityLiving
+//            RenderLiving, SheepMob, BaseModel, Mob
 
-public class SheepRenderer extends LivingRenderer<EntitySheep>
+public class SheepRenderer extends MobRenderer<SheepMob>
 {
-    public SheepRenderer(ModelBase body, ModelBase wool, ModelBase overlay, float f)
+    public SheepRenderer(BaseModel body, BaseModel wool, BaseModel overlay, float f)
     {
         super(body, f);
-        setRenderPassModel(wool);
+        setArmorModel(wool);
         setOverlayModel(overlay, "/assets/minecraft/textures/entity/sheep_overlay.png");
     }
 
-    protected boolean setWoolColorAndRender(EntitySheep entitysheep, int i, float f)
+    protected boolean setWoolColorAndRender(SheepMob entitysheep, int i, float f)
     {
         if(i == 0 && !entitysheep.getSheared())
         {
-            loadTexture("/assets/minecraft/textures/entity/sheep_fur.png");
+            bindTexture("/assets/minecraft/textures/entity/sheep_fur.png");
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled() || Global.accessor.isFullbrightEnabled()) {
             	
             }else {
             	brightness = entitysheep.getBrightness(f);
             }
-            int j = entitysheep.getFleeceColor();
-            GL11.glColor3f(brightness * EntitySheep.fleeceColorTable[j][0], brightness * EntitySheep.fleeceColorTable[j][1], brightness * EntitySheep.fleeceColorTable[j][2]);
+            int j = entitysheep.getFleeceColor().blockMeta;
+            GL11.glColor3f(brightness * SheepMob.FLEECE_COLOR_TABLE[j][0], brightness * SheepMob.FLEECE_COLOR_TABLE[j][1], brightness * SheepMob.FLEECE_COLOR_TABLE[j][2]);
             return true;
         } else
         {
@@ -45,7 +45,7 @@ public class SheepRenderer extends LivingRenderer<EntitySheep>
     }
 
     @Override
-    protected boolean shouldRenderPass(EntitySheep entity, int renderPass, float partialTick)
+    protected boolean prepareArmor(SheepMob entity, int renderPass, float partialTick)
     {
         return setWoolColorAndRender(entity, renderPass, partialTick);
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/SlimeRenderer.java b/src/main/java/net/minecraft/client/render/entity/SlimeRenderer.java
index b94a0c816..a84f6942e 100644
--- a/src/main/java/net/minecraft/client/render/entity/SlimeRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SlimeRenderer.java
@@ -1,59 +1,59 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.core.entity.monster.EntitySlime;
+import net.minecraft.client.render.model.BaseModel;
+import net.minecraft.core.entity.monster.SlimeMob;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntitySlime, ModelBase, EntityLiving
+//            RenderLiving, SlimeMob, BaseModel, Mob
 
-public class SlimeRenderer extends LivingRenderer<EntitySlime>
+public class SlimeRenderer extends MobRenderer<SlimeMob>
 {
 
-    public SlimeRenderer(ModelBase modelbase, ModelBase modelbase1, float f)
+    public SlimeRenderer(BaseModel modelbase, BaseModel modelbase1, float f)
     {
         super(modelbase, f);
         scaleAmount = modelbase1;
     }
 
-    protected boolean renderSlimePassModel(EntitySlime entity, int i, float f)
+    protected boolean renderSlimePassModel(SlimeMob entity, int i, float f)
     {
         if(i == 0)
         {
-            setRenderPassModel(scaleAmount);
+            setArmorModel(scaleAmount);
             GL11.glEnable(2977 /*GL_NORMALIZE*/);
-            GL11.glEnable(3042 /*GL_BLEND*/);
+            GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             return true;
         }
         if(i == 1)
         {
-            GL11.glDisable(3042 /*GL_BLEND*/);
+            GL11.glDisable(GL11.GL_BLEND);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         }
         return false;
     }
 
-    protected void scaleSlime(EntitySlime entityslime, float f)
+    protected void scaleSlime(SlimeMob entityslime, float f)
     {
         int i = entityslime.getSlimeSize();
-        float f1 = (entityslime.field_767_b + (entityslime.field_768_a - entityslime.field_767_b) * f) / ((float)i * 0.5F + 1.0F);
+        float f1 = (entityslime.oSquish + (entityslime.squish - entityslime.oSquish) * f) / ((float)i * 0.5F + 1.0F);
         float f2 = 1.0F / (f1 + 1.0F);
         float f3 = i;
         GL11.glScalef(f2 * f3, (1.0F / f2) * f3, f2 * f3);
     }
 
     @Override
-    protected void preRenderCallback(EntitySlime entity, float f)
+    protected void setupScale(SlimeMob entity, float partialTick)
     {
-        scaleSlime(entity, f);
+        scaleSlime(entity, partialTick);
     }
 
     @Override
-    protected boolean shouldRenderPass(EntitySlime entity, int renderPass, float partialTick)
+    protected boolean prepareArmor(SlimeMob entity, int renderPass, float partialTick)
     {
         return renderSlimePassModel(entity, renderPass, partialTick);
     }
 
-    private final ModelBase scaleAmount;
+    private final BaseModel scaleAmount;
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
index a00bd7d1b..490ea3388 100644
--- a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
@@ -2,41 +2,33 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.model.ModelSpider;
-import net.minecraft.core.Global;
-import net.minecraft.core.entity.monster.EntitySpider;
+import net.minecraft.client.render.model.SpiderModel;
+import net.minecraft.core.entity.monster.SpiderMob;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, ModelSpider, EntitySpider, EntityLiving
+//            RenderLiving, SpiderModel, SpiderMob, Mob
 
-public class SpiderRenderer extends LivingRenderer<EntitySpider>
+public class SpiderRenderer extends MobRenderer<SpiderMob>
 {
 
     public SpiderRenderer()
     {
-        super(new ModelSpider(0), 1.0F);
-        setRenderPassModel(new ModelSpider(0.01f));
+        super(new SpiderModel(0), 1.0F);
+        setArmorModel(new SpiderModel(0.01f));
     }
-
-    protected float setSpiderDeathMaxRotation(EntitySpider spider)
-    {
-        return 180F;
-    }
-
-    protected boolean setSpiderEyeBrightness(EntitySpider spider, int renderPass, float partialTick)
+    protected boolean setSpiderEyeBrightness(SpiderMob spider, int renderPass, float partialTick)
     {
         if(renderPass == 0)
         {
-            boolean useVariants = Minecraft.getMinecraft(this).gameSettings.mobVariants.value;
-            loadTexture("/assets/minecraft/textures/entity/spider/eyes/" + (useVariants ? spider.getSkinVariant() : 0) + ".png");
+            bindTexture("/assets/minecraft/textures/entity/spider/eyes/" + spider.getTextureReference() + ".png");
             float brightness = spider.getBrightness(1.0f);
             if(LightmapHelper.isLightmapEnabled()) {
                 LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
             }
             float f1 = (1.0F - brightness) * 0.5F;
-            GL11.glEnable(3042 /*GL_BLEND*/);
-            GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
+            GL11.glEnable(GL11.GL_BLEND);
+            GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, f1);
             return true;
@@ -46,13 +38,13 @@ public class SpiderRenderer extends LivingRenderer<EntitySpider>
     }
 
     @Override
-    protected float getDeathMaxRotation(EntitySpider entity)
+    protected float getMaxDeathRotation(SpiderMob entity)
     {
-        return setSpiderDeathMaxRotation(entity);
+        return 180f;
     }
 
     @Override
-    protected boolean shouldRenderPass(EntitySpider entity, int renderPass, float partialTick) {
+    protected boolean prepareArmor(SpiderMob entity, int renderPass, float partialTick) {
         return setSpiderEyeBrightness(entity, renderPass, partialTick);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/SnowballRenderer.java b/src/main/java/net/minecraft/client/render/entity/SpriteRenderer.java
similarity index 55%
rename from src/main/java/net/minecraft/client/render/entity/SnowballRenderer.java
rename to src/main/java/net/minecraft/client/render/entity/SpriteRenderer.java
index 2c5b5dd67..d97d28e2a 100644
--- a/src/main/java/net/minecraft/client/render/entity/SnowballRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SpriteRenderer.java
@@ -1,35 +1,56 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 // Referenced classes of package net.minecraft.src:
 //            Render, Tessellator, RenderManager, Entity
 
-public class SnowballRenderer extends EntityRenderer<Entity>
+public class SpriteRenderer<T extends Entity> extends EntityRenderer<T>
 {
-    public SnowballRenderer(Item item){
+    private IconCoordinate itemIconIndex;
+    private float scale = 1;
+    private boolean fullBright = false;
+
+    public SpriteRenderer(Item item){
         this(ItemModelDispatcher.getInstance().getDispatch(item).getIcon(null, item.getDefaultStack()));
     }
-
-    public SnowballRenderer(IconCoordinate i)
+    public SpriteRenderer(IconCoordinate i)
     {
         itemIconIndex = i;
     }
 
+    public SpriteRenderer setFullBright(){
+        fullBright = true;
+        return this;
+    }
+    public SpriteRenderer setScale(float scale){
+        this.scale = scale;
+        return this;
+    }
+
     @Override
-    public void doRender(Tessellator tessellator, Entity entity, double x, double y, double z,
-                         float yaw, float partialTick)
+    public void render(Tessellator tessellator, T entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         GL11.glPushMatrix();
         GL11.glTranslatef((float) x, (float) y, (float) z);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
-        GL11.glScalef(0.5F, 0.5F, 0.5F);
-        itemIconIndex.parentAtlas.bindTexture();
+        if (fullBright){
+            GL11.glDisable(GL11.GL_LIGHTING);
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            if (LightmapHelper.isLightmapEnabled()){
+                LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
+            }
+        }
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GL11.glScalef(0.5F * scale, 0.5F * scale, 0.5F * scale);
+        itemIconIndex.parentAtlas.bind();
         float f2 = (float) itemIconIndex.getIconUMin();
         float f3 = (float) itemIconIndex.getIconUMax();
         float f4 = (float) itemIconIndex.getIconVMin();
@@ -46,9 +67,10 @@ public class SnowballRenderer extends EntityRenderer<Entity>
         tessellator.addVertexWithUV(f6 - f7, 1.0F - f8, 0.0D, f3, f4);
         tessellator.addVertexWithUV(0.0F - f7, 1.0F - f8, 0.0D, f2, f4);
         tessellator.draw();
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glPopMatrix();
+        if (fullBright){
+            GL11.glEnable(GL11.GL_LIGHTING);
+        }
     }
-
-    private IconCoordinate itemIconIndex;
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/SquidRenderer.java b/src/main/java/net/minecraft/client/render/entity/SquidRenderer.java
index f3ffe3d29..1818c6beb 100644
--- a/src/main/java/net/minecraft/client/render/entity/SquidRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SquidRenderer.java
@@ -1,43 +1,43 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
+import net.minecraft.client.render.model.BaseModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.animal.EntitySquid;
+import net.minecraft.core.entity.animal.SquidMob;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            RenderLiving, EntitySquid, ModelBase, EntityLiving, 
+//            RenderLiving, SquidMob, BaseModel, Mob,
 //            Entity
 
-public class SquidRenderer extends LivingRenderer<EntitySquid>
+public class SquidRenderer extends MobRenderer<SquidMob>
 {
-    public SquidRenderer(ModelBase modelbase, float f)
+    public SquidRenderer(BaseModel modelbase, float f)
     {
         super(modelbase, f);
     }
     @Override
-    protected float ticksExisted(EntitySquid squid, float partialTick)
+    protected float limbSway(SquidMob squid, float partialTick)
     {
-        return squid.limbAnglePrev + (squid.newLimbAngle - squid.limbAnglePrev) * partialTick;
+        return squid.oldTentacleAngle + (squid.tentacleAngle - squid.oldTentacleAngle) * partialTick;
     }
 
     @Override
-    protected void rotateModel(EntitySquid squid, float ticksExisted, float headYawOffset, float partialTick)
+    protected void setupRotations(SquidMob squid, float ticksExisted, float bodyYaw, float partialTick)
     {
-        float pitch = squid.prevPitch + (squid.newPitch - squid.prevPitch) * partialTick;
-        float yaw = squid.prevYaw + (squid.newYaw - squid.prevYaw) * partialTick;
+        float pitch = squid.xBodyRotO + (squid.xBodyRot - squid.xBodyRotO) * partialTick;
+        float yaw = squid.zBodyRotO + (squid.zBodyRot - squid.zBodyRotO) * partialTick;
         GL11.glTranslatef(0.0F, 0.5F, 0.0F);
-        GL11.glRotatef(180F - headYawOffset, 0.0F, 1.0F, 0.0F);
+        GL11.glRotatef(180F - bodyYaw, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(pitch, 1.0F, 0.0F, 0.0F);
         GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
         GL11.glTranslatef(0.0F, -1.2F, 0.0F);
     }
 
     @Override
-    public void doRenderPreview(Tessellator tessellator, EntitySquid squid, double x, double y, double z, float yaw, float partialTick) {
+    public void renderPreview(Tessellator tessellator, SquidMob squid, double x, double y, double z, float yaw, float partialTick) {
         GL11.glPushMatrix();
         GL11.glTranslatef(0.0f, 1.25f, 0.0f);
-        super.doRenderPreview(tessellator,squid, x, y, z, yaw, partialTick);
+        super.renderPreview(tessellator,squid, x, y, z, yaw, partialTick);
         GL11.glPopMatrix();
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java b/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
index 4503ceba7..8db933283 100644
--- a/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/TNTRenderer.java
@@ -3,18 +3,19 @@ package net.minecraft.client.render.entity;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.entity.EntityTNT;
+import net.minecraft.core.entity.TNTPrimedEntity;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            Render, RenderBlocks, EntityTNTPrimed, Block, 
 //            Entity
 
-public class TNTRenderer extends EntityRenderer<EntityTNT>
+public class TNTRenderer extends EntityRenderer<TNTPrimedEntity>
 {
 
     public TNTRenderer()
@@ -23,7 +24,7 @@ public class TNTRenderer extends EntityRenderer<EntityTNT>
         shadowSize = 0.5F;
     }
 
-    public void renderTNT(EntityTNT tnt, double d, double d1, double d2,
+    public void renderTNT(TNTPrimedEntity tnt, double d, double d1, double d2,
                           float f, float f1)
     {
         Tessellator tessellator = Tessellator.instance;
@@ -46,30 +47,30 @@ public class TNTRenderer extends EntityRenderer<EntityTNT>
             GL11.glScalef(f4, f4, f4);
         }
         float f3 = (1.0F - (((float)tnt.fuse - f1) + 1.0F) / 100F) * 0.8F;
-        TextureRegistry.blockAtlas.bindTexture();
+        TextureRegistry.blockAtlas.bind();
         float brightness = tnt.getBrightness(f1);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(Block.tnt);
+        BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
         model.renderBlockOnInventory(tessellator, 0, brightness, null);
         if((tnt.fuse / 5) % 2 == 0)
         {
-            GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-            GL11.glDisable(2896 /*GL_LIGHTING*/);
-            GL11.glEnable(3042 /*GL_BLEND*/);
+            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            GL11.glDisable(GL11.GL_LIGHTING);
+            GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(770, 772);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, f3);
             model.renderBlockOnInventory(tessellator, 0, 1.0F, null);
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            GL11.glDisable(3042 /*GL_BLEND*/);
-            GL11.glEnable(2896 /*GL_LIGHTING*/);
-            GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
+            GL11.glDisable(GL11.GL_BLEND);
+            GL11.glEnable(GL11.GL_LIGHTING);
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
         }
         GL11.glPopMatrix();
     }
 
     @Override
-    public void doRender(Tessellator tessellator, EntityTNT entity, double x, double y, double z,
-                         float yaw, float partialTick)
+    public void render(Tessellator tessellator, TNTPrimedEntity entity, double x, double y, double z,
+                       float yaw, float partialTick)
     {
         renderTNT(entity, x, y, z, yaw, partialTick);
     }
diff --git a/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java b/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java
index 219de8364..3cde6fbb5 100644
--- a/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java
@@ -2,79 +2,62 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.model.ModelWolf;
+import net.minecraft.client.render.model.WolfModel;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.entity.animal.WolfMob;
+
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
-public class WolfRenderer extends LivingRenderer<EntityWolf>
+public class WolfRenderer extends MobRenderer<WolfMob>
 {
-    private final ModelWolf modelArmor;
-    protected ModelWolf modelWolfMain;
+    private final WolfModel modelArmor;
+    protected WolfModel modelWolfMain;
 
-    public WolfRenderer(ModelWolf modelWolf, float shadowSize)
+    public WolfRenderer(WolfModel modelWolf, float shadowSize)
     {
         super(modelWolf, shadowSize);
         modelWolfMain = modelWolf;
-        modelArmor = new ModelWolf(0.25f);
+        modelArmor = new WolfModel(0.25f);
     }
 
-    protected boolean setArmorModel(EntityWolf wolf, int renderPass, float renderPartialTicks) {
+    @Override
+    protected boolean prepareArmor(WolfMob wolf, int layer, float partialTick) {
         ArmorMaterial material = wolf.getArmorMaterial();
         if (material == null) {
             return false;
         }
-        loadTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace, material.identifier.value));
-        setRenderPassModel(modelArmor);
+        bindTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace, material.identifier.value));
+        setArmorModel(modelArmor);
         return true;
     }
-
-    @Override
-    protected boolean shouldRenderPass(EntityWolf entity, int renderPass, float renderPartialTicks) {
-        return setArmorModel(entity, renderPass, renderPartialTicks);
-    }
-
-    public void renderWolf(EntityWolf wolf, double x, double y, double z,
-                           float yaw, float partialTicks)
-    {
-        super.render(wolf, x, y, z, yaw, partialTicks);
-    }
-
-    protected float getTailRotation(EntityWolf wolf, float partialTicks)
-    {
-        return wolf.getTailRotation();
-    }
-
     @Override
-    protected float ticksExisted(EntityWolf entity, float partialTick)
+    protected float limbSway(WolfMob wolf, float partialTick)
     {
-        return getTailRotation(entity, partialTick);
-    }
-
-    @Override
-    public void render(EntityWolf entity, double x, double y, double z,
-                       float yaw, float partialTick)
-    {
-        renderWolf(entity, x, y, z, yaw, partialTick);
-    }
-
-    @Override
-    public void doRender(Tessellator tessellator, EntityWolf entity, double x, double y, double z,
-                         float yaw, float partialTick)
-    {
-        renderWolf(entity, x, y, z, yaw, partialTick);
+        if(wolf.isWolfAngry())
+        {
+            return 88 * (MathHelper.PI / 180F);
+        }
+        else if(wolf.isWolfTamed())
+        {
+            return (0.55F - (float)(wolf.getMaxHealth() - wolf.getHealth()) * 0.02F) * MathHelper.PI;
+        }
+        else
+        {
+            return 36 * (MathHelper.PI / 180F);
+        }
     }
 
     @Override
-    protected void renderEquippedItems(EntityWolf entity, float f){
+    protected void renderAdditional(WolfMob entity, float f){
         ItemStack itemstack = entity.getWolfHeldItem();
 
         if(itemstack != null && itemstack.getItem() != null) {
             GL11.glPushMatrix();
-            modelWolfMain.wolfHeadMain.postRender(0.0625F);
+            modelWolfMain.wolfHeadMain.translateTo(0.0625F);
             GL11.glTranslatef(-0.0625F, 0.4375F, 0.0625F);
             float scale;
             if (itemstack.itemID > 0 && itemstack.itemID < Block.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d()) {
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
rename to src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
index dd0d26edd..9f16c0e72 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/src/main/java/net/minecraft/client/render/item/model/BlockItemModel.java
@@ -8,34 +8,35 @@ import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.ItemBlock;
+import net.minecraft.core.item.block.BlockItem;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 import java.util.Random;
 
 import static org.lwjgl.opengl.GL11.*;
 
-public class ItemModelBlock extends ItemModelStandard {
+public class BlockItemModel extends StandardItemModel {
     private Block block;
     private BlockModel<Block> blockModel;
-    public ItemModelBlock(ItemBlock itemBlock){
-        super(itemBlock, null);
-        this.block = itemBlock.getBlock();
+    public BlockItemModel(BlockItem blockItem){
+        super(blockItem, null);
+        this.block = blockItem.getBlock();
         this.blockModel = BlockModelDispatcher.getInstance().getDispatch(block);
         icon = blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, 0);
     }
     @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, EntityPlayer player, ItemStack stack, float partialTick) {
+    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
         final Minecraft mc = Minecraft.getMinecraft(this);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
@@ -58,7 +59,7 @@ public class ItemModelBlock extends ItemModelStandard {
         GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
         GL11.glTranslatef(0.7F * distanceScale, -0.65F * distanceScale - (1.0F - renderer.getEquippedProgress(partialTick)) * 0.6F, -0.9F * distanceScale); // Positions hand in correct place on right side of screen
         GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F); // 45 degrees tilt, makes it face more towards the camera
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
         float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
         GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
@@ -80,7 +81,7 @@ public class ItemModelBlock extends ItemModelStandard {
         {
             GL11.glEnable(GL_BLEND);
             GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
             GL11.glDisable(GL_BLEND);
         } else {
@@ -107,7 +108,7 @@ public class ItemModelBlock extends ItemModelStandard {
         GL11.glEnable(GL_CULL_FACE);
         if (BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).shouldItemRender3d()) {
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             GL11.glPushMatrix();
             GL11.glTranslatef(x - 2, y + 3, -3F);
             GL11.glScalef(10F, 10F, 10F);
@@ -140,7 +141,7 @@ public class ItemModelBlock extends ItemModelStandard {
     public void renderAsItemEntity(Tessellator tessellator, Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
         if (Block.blocksList[itemstack.itemID] != null && BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemstack.itemID]).shouldItemRender3d()) {
             GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             final float itemSize = blockModel.getItemRenderScale();
             GL11.glScalef(itemSize, itemSize, itemSize);
             for (int i = 0; i < renderCount; i++) {
@@ -174,7 +175,7 @@ public class ItemModelBlock extends ItemModelStandard {
         GL11.glEnable(GL_CULL_FACE);
         if (BlockModelDispatcher.getInstance().getDispatch(Block.blocksList[itemStack.itemID]).shouldItemRender3d()) {
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             if (useColor) {
                 final int color = getColor(itemStack);
                 final float r = (color >> 16 & 0xff) / 255F;
